/* Trigger: INSERE_ESTRUTURA_FILIAL
   Tabela : FILIAL

   Criao:
   10/02/2014 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE TRIGGER INSERE_ESTRUTURA_FILIAL
AFTER INSERT
ON FILIAL FOR EACH ROW
DECLARE
   V_PRXCODIGO_M           VARCHAR2(20);
   V_PRXCODIGO_H           VARCHAR2(20);
   V_PRXCODIGO_PARCNEGOCIO VARCHAR2(20);
   V_CDSITUCRT             VARCHAR2(01);
   V_DTREFERENCIA          DATE;
   V_COUNT               NUMBER;
   V_TIPOINSC              VARCHAR2(10);
   V_TIPOPARC              VARCHAR2(12);
BEGIN
   V_DTREFERENCIA := TO_DATE('01/01/2000', 'DD/MM/YYYY');
   FOR C_FILIAL IN
      (SELECT :NEW.CDFILIAL CDFILIAL,
              :NEW.NMFILIAL NMFILIAL,
              :NEW.NRORG NRORG,
              :NEW.CDEMPRESA CDEMPRESA,
              REPLACE(REPLACE(REPLACE(REPLACE(:NEW.NRINSJURFILI, '.',''),'/',''),'-',''),' ','') NRINSJURFILI
         FROM DUAL
        WHERE NOT EXISTS (SELECT 1
                            FROM ESTRUTURAM
                           WHERE CDINTESTRUTURA = :NEW.CDFILIAL
                             AND NRTIPOESTRUTURA = 2))
   LOOP
      /*VERIFICA SE A EMPRESA  DO SIMPLES NACIONAL, '3' NAO  DO SIMPLES, APENAS 1 E 2*/
      SELECT NVL(MAX(CDSITUCRT), '3') CDSITUCRT
        INTO V_CDSITUCRT
        FROM PARAMEMPRESA
       WHERE CDEMPRESA = C_FILIAL.CDEMPRESA;

      NOVO_CODIGO_SC('ESTRUTURAM', V_PRXCODIGO_M);
      NOVO_CODIGO_SC('ESTRUTURAH', V_PRXCODIGO_H);
      NOVO_CODIGO_SC('PARCNEGOCIO', V_PRXCODIGO_PARCNEGOCIO);

      INSERT INTO PARCNEGOCIO(NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC,
                              IDATIVO, DTINCLUSAO, CDTIPOINSCRICAO, IDPESSOAFISICA, IDINSTITUICAO,
                              CDTIPOPARCPRINCIPAL)
      VALUES(TO_NUMBER(V_PRXCODIGO_PARCNEGOCIO), C_FILIAL.NRORG, C_FILIAL.NMFILIAL, C_FILIAL.NMFILIAL, NVL(C_FILIAL.NRINSJURFILI, C_FILIAL.CDFILIAL),
      'S', SYSDATE, 'CNPJ', 'N', 'S', 'ESTRUTURA');

      INSERT INTO ESTRUTURAM(NRESTRUTURAM, CDINTESTRUTURA, NRORG, NRTIPOESTRUTURA, DTINIVIGENCIA, DTINCLUSAO)
      VALUES(TO_NUMBER(V_PRXCODIGO_M), C_FILIAL.CDFILIAL, C_FILIAL.NRORG, 2, V_DTREFERENCIA, SYSDATE);

      INSERT INTO ESTRUTURAH(NRESTRUTURAM, NRESTRUTURAH, NRORG, DTMESCOMPETENC, IDOPTSIMPLES, DTINCLUSAO,
                             CDCNPJESTRUT, NMRAZSOCESTRUT, NRPARCNEGOCIO)
      VALUES(TO_NUMBER(V_PRXCODIGO_M), TO_NUMBER(V_PRXCODIGO_H), C_FILIAL.NRORG, V_DTREFERENCIA, DECODE(V_CDSITUCRT, '3', 'N', 'S'), SYSDATE,
      C_FILIAL.NRINSJURFILI, C_FILIAL.NMFILIAL, TO_NUMBER(V_PRXCODIGO_PARCNEGOCIO));
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('INSERE_ESTRUTURA_FILIAL','5.70.000'); END;
/
