/*
 Tecnisa - Tecnologia em Informtica

 Nome: Exclui contas exportadas

 Descrio:
 Procedimento para excluso de todas as contas ligadas  nota fiscal, boletos referentes as contas,
   baixas e movimentos bancarios

 Criao:
 26/04/2002 - Jenilson Ferreira de Andrade

 Chamada para criao
 @C:\Win_Prj\Sql\SqlServer\1006_RECSTP_EXCLUI_CONTAREC_EXPORTADA.SQL;

 */

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'EXCLUI_CONTAREC_EXPORTADA' AND
              TYPE   = 'P'           	           AND
              U.UID  = O.UID                       AND
              U.NAME = USER)

DROP PROCEDURE EXCLUI_CONTAREC_EXPORTADA
GO

CREATE PROCEDURE EXCLUI_CONTAREC_EXPORTADA
   @P_CDFILIAL    VARCHAR(04),
   @P_NRLANCTONF  VARCHAR(10)

AS
   DECLARE @V_CDREDUBX                 VARCHAR(03);
   DECLARE @V_NRMOVBANC                VARCHAR(10);
   DECLARE @V_CDSEQUEXBA               VARCHAR(10);
   DECLARE @V_NRSEQMOVREBA             VARCHAR(10);
   DECLARE @V_CDFILIBAIREC             VARCHAR(04);
   DECLARE @V_NRBAIXAREC               VARCHAR(10);

   DECLARE @V_VRAJBOLREC               DOUBLE PRECISION;
   DECLARE @V_VRAJUCTREC               DOUBLE PRECISION;
   DECLARE @V_VRORIGREC                DOUBLE PRECISION;

   DECLARE @V_CNTREC_CDFILIAL          VARCHAR(04);
   DECLARE @V_CNTREC_NRLANCTONF        VARCHAR(10);
   DECLARE @V_CNTREC_NRSEQVENREC       VARCHAR(02);
   DECLARE @V_CNTREC_VRATUAREC         DOUBLE PRECISION;
   DECLARE @V_CNTREC_CDFILIBOLREC      VARCHAR(04);
   DECLARE @V_CNTREC_NRLANBOLREC       VARCHAR(10);
   DECLARE @V_CNTREC_CDEMPRESA         VARCHAR(02);
   DECLARE @V_CNTREC_CDFIMOVFLREC      VARCHAR(04);
   DECLARE @V_CNTREC_DTMOVFLUXO        DATETIME;
   DECLARE @V_CNTREC_IDMOVFLUXO        VARCHAR(01);
   DECLARE @V_CNTREC_CDCLASSFINA       VARCHAR(06);
   DECLARE @V_CNTREC_VRORIGREC         DOUBLE PRECISION;
   DECLARE @V_CNTREC_NRPARCELAREC      VARCHAR(02);

   DECLARE @V_CNTREC_BX_CDFILIAL       VARCHAR(04);
   DECLARE @V_CNTREC_BX_NRLANCTONF     VARCHAR(10);
   DECLARE @V_CNTREC_BX_NRSEQVENREC    VARCHAR(02);
   DECLARE @V_CNTREC_BX_CDFILIBOLREC   VARCHAR(04);
   DECLARE @V_CNTREC_BX_NRLANBOLREC    VARCHAR(10);
   DECLARE @V_CNTREC_BX_CDEMPRESA      VARCHAR(02);
   DECLARE @V_CNTREC_BX_CDFIMOVFLREC   VARCHAR(04);
   DECLARE @V_CNTREC_BX_DTMOVFLUXO     DATETIME;
   DECLARE @V_CNTREC_BX_IDMOVFLUXO     VARCHAR(01);
   DECLARE @V_CNTREC_BX_CDCLASSFINA    VARCHAR(06);
   DECLARE @V_CNTREC_BX_VRORIGREC      DOUBLE PRECISION;
   DECLARE @V_CNTREC_BX_NRPARCELAREC   VARCHAR(02);

   DECLARE @V_BOLETREC_AB_CDFILIAL     VARCHAR(04);
   DECLARE @V_BOLETREC_AB_NRLANCTONF   VARCHAR(10);
   DECLARE @V_BOLETREC_AB_NRSEQVENREC  VARCHAR(02);
   DECLARE @V_BOLETREC_AB_CDFILIBOLREC VARCHAR(04);
   DECLARE @V_BOLETREC_AB_NRLANBOLREC  VARCHAR(10);
   DECLARE @V_BOLETREC_AB_CDEMPRESA    VARCHAR(02);
   DECLARE @V_BOLETREC_AB_CDFIMOVFLREC VARCHAR(04);
   DECLARE @V_BOLETREC_AB_DTMOVFLUXO   DATETIME;
   DECLARE @V_BOLETREC_AB_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_BOLETREC_AB_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_BOLETREC_AB_VRORIGREC    DOUBLE PRECISION;
   DECLARE @V_BOLETREC_AB_NRPARCELAREC VARCHAR(02);

   DECLARE @V_RATR_A_CDFILIAL          VARCHAR(04);
   DECLARE @V_RATR_A_NRLANBOLREC       VARCHAR(10);
   DECLARE @V_RATR_A_CDAJUCTREC        VARCHAR(04);
   DECLARE @V_RATR_A_VRAJBOLREC        DOUBLE PRECISION;
   DECLARE @V_RATR_A_CDCLASSFINA       VARCHAR(06);
   DECLARE @V_RATR_A_CDEMPRESA         VARCHAR(02);
   DECLARE @V_RATR_A_CDFIMOVFLREC      VARCHAR(04);
   DECLARE @V_RATR_A_DTMOVFLUXO        DATETIME;
   DECLARE @V_RATR_A_IDMOVFLUXO        VARCHAR(01);
   DECLARE @V_RATR_A_IDAJUCTREC        VARCHAR(01);
   DECLARE @V_RATR_A_IDSTATREC         VARCHAR(01);
   DECLARE @V_RATR_A_VRRATAJBOLREC     DOUBLE PRECISION;

   DECLARE @V_RATR_B_CDFILIAL          VARCHAR(04);
   DECLARE @V_RATR_B_NRLANBOLREC       VARCHAR(10);
   DECLARE @V_RATR_B_CDAJUCTREC        VARCHAR(04);
   DECLARE @V_RATR_B_VRAJBOLREC        DOUBLE PRECISION;
   DECLARE @V_RATR_B_CDCLASSFINA       VARCHAR(06);
   DECLARE @V_RATR_B_CDEMPRESA         VARCHAR(02);
   DECLARE @V_RATR_B_CDFIMOVFLREC      VARCHAR(04);
   DECLARE @V_RATR_B_DTMOVFLUXO        DATETIME;
   DECLARE @V_RATR_B_IDMOVFLUXO        VARCHAR(01);
   DECLARE @V_RATR_B_IDAJUCTREC        VARCHAR(01);
   DECLARE @V_RATR_B_IDSTATREC         VARCHAR(01);
   DECLARE @V_RATR_B_VRRATAJBOLREC     DOUBLE PRECISION;

   DECLARE @V_AJCTREC_A_CDFILIAL       VARCHAR(04);
   DECLARE @V_AJCTREC_A_NRLANCTONF     VARCHAR(10);
   DECLARE @V_AJCTREC_A_CDAJUCTREC     VARCHAR(04);
   DECLARE @V_AJCTREC_A_CDCLASSFINA    VARCHAR(06);
   DECLARE @V_AJCTREC_A_CDEMMFAJCNTR   VARCHAR(02);
   DECLARE @V_AJCTREC_A_CDFIMFAJCNTR   VARCHAR(04);
   DECLARE @V_AJCTREC_A_DTMOVFLUXO     DATETIME;
   DECLARE @V_AJCTREC_A_IDMOVFLUXO     VARCHAR(01);
   DECLARE @V_AJCTREC_A_VRAJUSTEREC    DOUBLE PRECISION;
   DECLARE @V_AJCTREC_A_IDAJUCTREC     VARCHAR(01);
   DECLARE @V_AJCTREC_A_NRSEQVENREC    VARCHAR(02);
   DECLARE @V_AJCTREC_A_NRPARCELAREC   VARCHAR(02);

   DECLARE @V_AJCTREC_B_CDFILIAL       VARCHAR(04);
   DECLARE @V_AJCTREC_B_NRLANCTONF     VARCHAR(10);
   DECLARE @V_AJCTREC_B_CDAJUCTREC     VARCHAR(04);
   DECLARE @V_AJCTREC_B_CDCLASSFINA    VARCHAR(06);
   DECLARE @V_AJCTREC_B_CDEMMFAJCNTR   VARCHAR(02);
   DECLARE @V_AJCTREC_B_CDFIMFAJCNTR   VARCHAR(04);
   DECLARE @V_AJCTREC_B_DTMOVFLUXO     DATETIME;
   DECLARE @V_AJCTREC_B_IDMOVFLUXO     VARCHAR(01);
   DECLARE @V_AJCTREC_B_VRAJUSTEREC    DOUBLE PRECISION;
   DECLARE @V_AJCTREC_B_IDAJUCTREC     VARCHAR(01);
   DECLARE @V_AJCTREC_B_NRSEQVENREC    VARCHAR(02);
   DECLARE @V_AJCTREC_B_NRPARCELAREC   VARCHAR(02);

   DECLARE @V_BOLETREC_BX_CDFILIAL     VARCHAR(04);
   DECLARE @V_BOLETREC_BX_NRLANBOLREC  VARCHAR(10);
   DECLARE @V_BOLETREC_BX_CDFILIBAIREC VARCHAR(04);
   DECLARE @V_BOLETREC_BX_NRBAIXAREC   VARCHAR(10);

BEGIN

   DECLARE C_CNTREC CURSOR FOR
      SELECT CDFILIAL,    NRLANCTONF,   NRSEQVENREC,
             VRATUAREC,   CDFILIBOLREC, NRLANBOLREC,
             CDEMPRESA,   CDFIMOVFLREC, DTMOVFLUXO,
             IDMOVFLUXO,  CDCLASSFINA,  VRORIGREC,
             NRPARCELAREC
      FROM CONTARECEBER
      WHERE CDFILIAL   = @P_CDFILIAL AND
            NRLANCTONF = @P_NRLANCTONF
      ORDER BY NRSEQVENREC;
   OPEN C_CNTREC;

   FETCH NEXT FROM C_CNTREC INTO @V_CNTREC_CDFILIAL,    @V_CNTREC_NRLANCTONF,   @V_CNTREC_NRSEQVENREC,
                                 @V_CNTREC_VRATUAREC,   @V_CNTREC_CDFILIBOLREC, @V_CNTREC_NRLANBOLREC,
                                 @V_CNTREC_CDEMPRESA,   @V_CNTREC_CDFIMOVFLREC, @V_CNTREC_DTMOVFLUXO,
                                 @V_CNTREC_IDMOVFLUXO,  @V_CNTREC_CDCLASSFINA,  @V_CNTREC_VRORIGREC,
                                 @V_CNTREC_NRPARCELAREC;
   WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT
         @V_CDFILIBAIREC = MAX(BR.CDFILIBAIREC),
         @V_NRBAIXAREC   = MAX(BR.NRBAIXAREC)
      FROM BOLETRECEBER BR, CONTARECEBER CR
      WHERE
         (CR.CDFILIAL     = @V_CNTREC_CDFILIAL)     AND
         (CR.NRLANCTONF   = @V_CNTREC_NRLANCTONF)   AND
         (CR.NRSEQVENREC  = @V_CNTREC_NRSEQVENREC)  AND
         (CR.NRPARCELAREC = @V_CNTREC_NRPARCELAREC) AND
         (CR.CDFILIBOLREC = BR.CDFILIAL)            AND
         (CR.NRLANBOLREC  = BR.NRLANBOLREC);


      DECLARE C_BOLETREC_BX CURSOR FOR
         SELECT CDFILIAL,     NRLANBOLREC,
                CDFILIBAIREC, NRBAIXAREC
         FROM BOLETRECEBER
         WHERE (CDFILIBAIREC = @V_CDFILIBAIREC) AND
               (NRBAIXAREC   = @V_NRBAIXAREC);
      OPEN C_BOLETREC_BX;
      FETCH NEXT FROM C_BOLETREC_BX INTO @V_BOLETREC_BX_CDFILIAL,     @V_BOLETREC_BX_NRLANBOLREC,
                                         @V_BOLETREC_BX_CDFILIBAIREC, @V_BOLETREC_BX_NRBAIXAREC;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         DECLARE C_RATR_A CURSOR FOR
            SELECT AJ.CDFILIAL,     AJ.NRLANBOLREC, AJ.CDAJUCTREC,
                   AJ.VRAJBOLREC,   CR.CDCLASSFINA, CR.CDEMPRESA,
                   CR.CDFIMOVFLREC, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
                   TA.IDAJUCTREC,   CR.IDSTATREC,
                   (CASE MAX(BR.VRBOLREC) WHEN 0
                    THEN 0
                    ELSE (MAX(AJ.VRAJBOLREC) * SUM(CR.VRATUAREC))/ MAX(BR.VRBOLREC) END) VRRATAJBOLREC
            FROM CONTARECEBER  CR, BOLETRECEBER BR,
                 TIPOAJRECEBER TA, AJBOLREC   AJ
            WHERE (AJ.CDFILIAL     = @V_BOLETREC_BX_CDFILIAL)    AND
                  (AJ.NRLANBOLREC  = @V_BOLETREC_BX_NRLANBOLREC) AND
                  (TA.CDAJUCTREC   = AJ.CDAJUCTREC)          AND
                  (BR.CDFILIAL     = AJ.CDFILIAL)            AND
                  (BR.NRLANBOLREC  = AJ.NRLANBOLREC)         AND
                  (CR.CDFILIBOLREC = BR.CDFILIAL)            AND
                  (CR.NRLANBOLREC  = BR.NRLANBOLREC)
            GROUP BY
               AJ.CDFILIAL,     AJ.NRLANBOLREC, AJ.CDAJUCTREC,
               AJ.VRAJBOLREC,   CR.CDCLASSFINA, CR.CDEMPRESA,
               CR.CDFIMOVFLREC, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
               TA.IDAJUCTREC,   CR.IDSTATREC;
         OPEN C_RATR_A;
         FETCH NEXT FROM C_RATR_A INTO @V_RATR_A_CDFILIAL,     @V_RATR_A_NRLANBOLREC, @V_RATR_A_CDAJUCTREC,
                                       @V_RATR_A_VRAJBOLREC,   @V_RATR_A_CDCLASSFINA, @V_RATR_A_CDEMPRESA,
                                       @V_RATR_A_CDFIMOVFLREC, @V_RATR_A_DTMOVFLUXO,  @V_RATR_A_IDMOVFLUXO,
                                       @V_RATR_A_IDAJUCTREC,   @V_RATR_A_IDSTATREC,   @V_RATR_A_VRRATAJBOLREC
         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (@V_RATR_A_IDAJUCTREC = 'D') BEGIN
               SET @V_VRAJBOLREC = ROUND(@V_RATR_A_VRRATAJBOLREC, 2);
            END
            ELSE BEGIN
               SET @V_VRAJBOLREC = ROUND(@V_RATR_A_VRRATAJBOLREC * -1, 2);
            END;
            /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_RATR_A_CDEMPRESA,
                                         @V_RATR_A_CDFIMOVFLREC,
                                         @V_RATR_A_DTMOVFLUXO,
                                         @V_RATR_A_IDMOVFLUXO,
                                         @V_RATR_A_CDCLASSFINA,
                                         @V_VRAJBOLREC,
                                         0;

            DELETE FROM MOVFXAJBOLR
            WHERE CDFILIBOLREC = @V_BOLETREC_BX_CDFILIAL    AND
                  NRLANBOLREC  = @V_BOLETREC_BX_NRLANBOLREC AND
                  CDAJUCTREC   = @V_RATR_A_CDAJUCTREC;

            FETCH NEXT FROM C_RATR_A INTO @V_RATR_A_CDFILIAL,     @V_RATR_A_NRLANBOLREC, @V_RATR_A_CDAJUCTREC,
                                          @V_RATR_A_VRAJBOLREC,   @V_RATR_A_CDCLASSFINA, @V_RATR_A_CDEMPRESA,
                                          @V_RATR_A_CDFIMOVFLREC, @V_RATR_A_DTMOVFLUXO,  @V_RATR_A_IDMOVFLUXO,
                                          @V_RATR_A_IDAJUCTREC,   @V_RATR_A_IDSTATREC,   @V_RATR_A_VRRATAJBOLREC
         END;
         CLOSE C_RATR_A;
         DEALLOCATE C_RATR_A;

         DELETE FROM AJBOLREC
         WHERE CDFILIAL    = @V_BOLETREC_BX_CDFILIAL AND
               NRLANBOLREC = @V_BOLETREC_BX_NRLANBOLREC;

         DECLARE C_CNTREC_BX CURSOR FOR
            SELECT CDFILIAL,     NRLANCTONF,  NRSEQVENREC,
                   CDFILIBOLREC, NRLANBOLREC, CDEMPRESA,
                   CDFIMOVFLREC, DTMOVFLUXO,  IDMOVFLUXO,
                   CDCLASSFINA,  VRORIGREC,   NRPARCELAREC
            FROM CONTARECEBER
            WHERE CDFILIBOLREC = @V_BOLETREC_BX_CDFILIAL AND
                  NRLANBOLREC  = @V_BOLETREC_BX_NRLANBOLREC
            ORDER BY NRSEQVENREC;
         OPEN C_CNTREC_BX;
         FETCH NEXT FROM C_CNTREC_BX INTO @V_CNTREC_BX_CDFILIAL,     @V_CNTREC_BX_NRLANCTONF,  @V_CNTREC_BX_NRSEQVENREC,
                                          @V_CNTREC_BX_CDFILIBOLREC, @V_CNTREC_BX_NRLANBOLREC, @V_CNTREC_BX_CDEMPRESA,
                                          @V_CNTREC_BX_CDFIMOVFLREC, @V_CNTREC_BX_DTMOVFLUXO,  @V_CNTREC_BX_IDMOVFLUXO,
                                          @V_CNTREC_BX_CDCLASSFINA,  @V_CNTREC_BX_VRORIGREC,   @V_CNTREC_BX_NRPARCELAREC;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            DECLARE C_AJCTREC_A CURSOR FOR
               SELECT AJ.CDFILIAL,    AJ.NRLANCTONF,   AJ.CDAJUCTREC,
                      AJ.CDCLASSFINA, AJ.CDEMMFAJCNTR, AJ.CDFIMFAJCNTR,
                      AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,   AJ.VRAJUSTEREC,
                      TA.IDAJUCTREC,  AJ.NRSEQVENREC,  AJ.NRPARCELAREC
               FROM AJCTRECEBER AJ, TIPOAJRECEBER TA
               WHERE (AJ.CDFILIAL     = @V_CNTREC_BX_CDFILIAL)     AND
                     (AJ.NRLANCTONF   = @V_CNTREC_BX_NRLANCTONF)   AND
                     (AJ.NRSEQVENREC  = @V_CNTREC_BX_NRSEQVENREC)  AND
                     (AJ.NRPARCELAREC = @V_CNTREC_BX_NRPARCELAREC) AND
                     (TA.CDAJUCTREC   = AJ.CDAJUCTREC);
            OPEN C_AJCTREC_A;

            FETCH NEXT FROM C_AJCTREC_A INTO @V_AJCTREC_A_CDFILIAL,    @V_AJCTREC_A_NRLANCTONF,   @V_AJCTREC_A_CDAJUCTREC,
                                             @V_AJCTREC_A_CDCLASSFINA, @V_AJCTREC_A_CDEMMFAJCNTR, @V_AJCTREC_A_CDFIMFAJCNTR,
                                             @V_AJCTREC_A_DTMOVFLUXO,  @V_AJCTREC_A_IDMOVFLUXO,   @V_AJCTREC_A_VRAJUSTEREC,
                                             @V_AJCTREC_A_IDAJUCTREC,  @V_AJCTREC_A_NRSEQVENREC,  @V_AJCTREC_A_NRPARCELAREC;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               IF (@V_AJCTREC_A_IDAJUCTREC = 'D') BEGIN
                  SET @V_VRAJUCTREC = ROUND(@V_AJCTREC_A_VRAJUSTEREC, 2);
               END
               ELSE BEGIN
                  SET @V_VRAJUCTREC = ROUND(@V_AJCTREC_A_VRAJUSTEREC * -1, 2);
               END;
               /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCTREC_A_CDEMMFAJCNTR,
                                            @V_AJCTREC_A_CDFIMFAJCNTR,
                                            @V_AJCTREC_A_DTMOVFLUXO,
                                            @V_AJCTREC_A_IDMOVFLUXO,
                                            @V_AJCTREC_A_CDCLASSFINA,
                                            @V_VRAJUCTREC,
                                            0;

               DELETE FROM AJCTRECEBER
               WHERE
                  (CDFILIAL     = @V_AJCTREC_A_CDFILIAL)     AND
                  (NRLANCTONF   = @V_AJCTREC_A_NRLANCTONF)   AND
                  (NRSEQVENREC  = @V_AJCTREC_A_NRSEQVENREC)  AND
                  (NRPARCELAREC = @V_AJCTREC_A_NRPARCELAREC);

               FETCH NEXT FROM C_AJCTREC_A INTO @V_AJCTREC_A_CDFILIAL,    @V_AJCTREC_A_NRLANCTONF,   @V_AJCTREC_A_CDAJUCTREC,
                                                @V_AJCTREC_A_CDCLASSFINA, @V_AJCTREC_A_CDEMMFAJCNTR, @V_AJCTREC_A_CDFIMFAJCNTR,
                                                @V_AJCTREC_A_DTMOVFLUXO,  @V_AJCTREC_A_IDMOVFLUXO,   @V_AJCTREC_A_VRAJUSTEREC,
                                                @V_AJCTREC_A_IDAJUCTREC,  @V_AJCTREC_A_NRSEQVENREC,  @V_AJCTREC_A_NRPARCELAREC;
            END;
            CLOSE C_AJCTREC_A;
            DEALLOCATE C_AJCTREC_A;

            SET @V_VRORIGREC = @V_CNTREC_BX_VRORIGREC * (-1);
            /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CNTREC_BX_CDEMPRESA,
                                         @V_CNTREC_BX_CDFIMOVFLREC,
                                         @V_CNTREC_BX_DTMOVFLUXO,
                                         @V_CNTREC_BX_IDMOVFLUXO,
                                         @V_CNTREC_BX_CDCLASSFINA,
                                         @V_VRORIGREC,
                                         0;

            DELETE FROM CONTARECEBER
            WHERE (CDFILIAL     = @V_CNTREC_BX_CDFILIAL)     AND
                  (NRLANCTONF   = @V_CNTREC_BX_NRLANCTONF)   AND
                  (NRSEQVENREC  = @V_CNTREC_BX_NRSEQVENREC)  AND
                  (NRPARCELAREC = @V_CNTREC_BX_NRPARCELAREC);

            FETCH NEXT FROM C_CNTREC_BX INTO @V_CNTREC_BX_CDFILIAL,     @V_CNTREC_BX_NRLANCTONF,  @V_CNTREC_BX_NRSEQVENREC,
                                             @V_CNTREC_BX_CDFILIBOLREC, @V_CNTREC_BX_NRLANBOLREC, @V_CNTREC_BX_CDEMPRESA,
                                             @V_CNTREC_BX_CDFIMOVFLREC, @V_CNTREC_BX_DTMOVFLUXO,  @V_CNTREC_BX_IDMOVFLUXO,
                                             @V_CNTREC_BX_CDCLASSFINA,  @V_CNTREC_BX_VRORIGREC,   @V_CNTREC_BX_NRPARCELAREC;
         END;
         CLOSE C_CNTREC_BX;
         DEALLOCATE C_CNTREC_BX;

         DELETE FROM BOLETRECEBER
         WHERE CDFILIAL    = @V_BOLETREC_BX_CDFILIAL AND
               NRLANBOLREC = @V_BOLETREC_BX_NRLANBOLREC;


         FETCH NEXT FROM C_BOLETREC_BX INTO @V_BOLETREC_BX_CDFILIAL,     @V_BOLETREC_BX_NRLANBOLREC,
                                            @V_BOLETREC_BX_CDFILIBAIREC, @V_BOLETREC_BX_NRBAIXAREC;
      END;
      CLOSE C_BOLETREC_BX;
      DEALLOCATE C_BOLETREC_BX;

      IF (NOT @V_NRBAIXAREC IS NULL) BEGIN
         SELECT
            @V_CDREDUBX  = MAX(BX.CDREDUCONT),
            @V_NRMOVBANC = MAX(BX.NRMOVBANC)
         FROM BAIXARECEBIDA BX
         WHERE
            (BX.CDFILIAL   = @V_BOLETREC_BX_CDFILIBAIREC) AND
            (BX.NRBAIXAREC = @V_BOLETREC_BX_NRBAIXAREC);

         SELECT
            @V_CDSEQUEXBA   = MAX(CDSEQUEXBA),
            @V_NRSEQMOVREBA = MAX(NRSEQMOVREBA)
         FROM MOVBANCARIO
         WHERE
            (CDREDUCONT = @V_CDREDUBX) AND
            (NRMOVBANC  = @V_NRMOVBANC);

         DELETE FROM BAIXARECEBIDA
         WHERE
            (CDFILIAL   = @V_BOLETREC_BX_CDFILIBAIREC) AND
            (NRBAIXAREC = @V_BOLETREC_BX_NRBAIXAREC);

         IF (NOT @V_CDSEQUEXBA   IS NULL) AND
            (NOT @V_NRSEQMOVREBA IS NULL) BEGIN
            UPDATE MOVBANCARIO
            SET
               IDSTCONEXT   = 0,
               IDCONCBANC   = NULL,
               CDSEQUEXBA   = NULL,
               NRSEQMOVREBA = NULL
            WHERE
               (CDREDUCONT   = @V_CDREDUBX)   AND
               (IDSTCONEXT   = '1')          AND
               (CDSEQUEXBA   = @V_CDSEQUEXBA) AND
               (NRSEQMOVREBA = @V_NRSEQMOVREBA);
         END;

         DELETE FROM MOVBANCARIO
         WHERE
            (CDREDUCONT = @V_CDREDUBX) AND
            (NRMOVBANC  = @V_NRMOVBANC);

         IF (NOT @V_CDSEQUEXBA   IS NULL) AND
            (NOT @V_NRSEQMOVREBA IS NULL) BEGIN
            UPDATE MOVREAL
            SET
               IDSTCONMVBAN = 0,
               IDCONCREAL   = NULL,
               NRMOVBARE    = NULL
            WHERE
               (CDREDUCONT   = @V_CDREDUBX) AND
               (CDSEQUEXTR   = @V_CDSEQUEXBA) AND
               (NRSEQMOVREAL = @V_NRSEQMOVREBA);
         END;
      END;

      /* BUSCA TODAS OS BOLETOS QUE NO ESTO LIGADOS A BAIXA  */
      DECLARE C_BOLETREC_AB CURSOR FOR
         SELECT CDFILIAL,     NRLANCTONF,  NRSEQVENREC,
                CDFILIBOLREC, NRLANBOLREC, CDEMPRESA,
                CDFIMOVFLREC, DTMOVFLUXO,  IDMOVFLUXO,
                CDCLASSFINA,  VRORIGREC,   NRPARCELAREC
         FROM CONTARECEBER
         WHERE (CDFILIBOLREC = @V_CNTREC_CDFILIBOLREC) AND
               (NRLANBOLREC  = @V_CNTREC_NRLANBOLREC)
         ORDER BY NRSEQVENREC;
      OPEN C_BOLETREC_AB;
      FETCH NEXT FROM C_BOLETREC_AB INTO @V_BOLETREC_AB_CDFILIAL,     @V_BOLETREC_AB_NRLANCTONF,  @V_BOLETREC_AB_NRSEQVENREC,
                                         @V_BOLETREC_AB_CDFILIBOLREC, @V_BOLETREC_AB_NRLANBOLREC, @V_BOLETREC_AB_CDEMPRESA,
                                         @V_BOLETREC_AB_CDFIMOVFLREC, @V_BOLETREC_AB_DTMOVFLUXO,  @V_BOLETREC_AB_IDMOVFLUXO,
                                         @V_BOLETREC_AB_CDCLASSFINA,  @V_BOLETREC_AB_VRORIGREC,   @V_BOLETREC_AB_NRPARCELAREC
      WHILE (@@FETCH_STATUS = 0) BEGIN

         DECLARE C_RATR_B CURSOR FOR
            SELECT AJ.CDFILIAL,     AJ.NRLANBOLREC, AJ.CDAJUCTREC,
                   AJ.VRAJBOLREC,   CR.CDCLASSFINA, CR.CDEMPRESA,
                   CR.CDFIMOVFLREC, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
                   TA.IDAJUCTREC,   CR.IDSTATREC,
                   (CASE MAX(BR.VRBOLREC) WHEN 0
                    THEN 0
                    ELSE (MAX(AJ.VRAJBOLREC) * SUM(CR.VRATUAREC))/ MAX(BR.VRBOLREC) END) VRRATAJBOLREC
            FROM CONTARECEBER  CR, BOLETRECEBER BR,
                 TIPOAJRECEBER TA, AJBOLREC   AJ
            WHERE (AJ.CDFILIAL     = @V_BOLETREC_AB_CDFILIBOLREC)    AND
                  (AJ.NRLANBOLREC  = @V_BOLETREC_AB_NRLANBOLREC) AND
                  (TA.CDAJUCTREC   = AJ.CDAJUCTREC)        AND
                  (BR.CDFILIAL     = AJ.CDFILIAL)          AND
                  (BR.NRLANBOLREC  = AJ.NRLANBOLREC)       AND
                  (CR.CDFILIBOLREC = BR.CDFILIAL)          AND
                  (CR.NRLANBOLREC  = BR.NRLANBOLREC)
            GROUP BY
               AJ.CDFILIAL,     AJ.NRLANBOLREC, AJ.CDAJUCTREC,
               AJ.VRAJBOLREC,   CR.CDCLASSFINA, CR.CDEMPRESA,
               CR.CDFIMOVFLREC, CR.DTMOVFLUXO,  CR.IDMOVFLUXO,
               TA.IDAJUCTREC,   CR.IDSTATREC;
         OPEN C_RATR_B;
         FETCH NEXT FROM C_RATR_B INTO @V_RATR_B_CDFILIAL,     @V_RATR_B_NRLANBOLREC, @V_RATR_B_CDAJUCTREC,
                                       @V_RATR_B_VRAJBOLREC,   @V_RATR_B_CDCLASSFINA, @V_RATR_B_CDEMPRESA,
                                       @V_RATR_B_CDFIMOVFLREC, @V_RATR_B_DTMOVFLUXO,  @V_RATR_B_IDMOVFLUXO,
                                       @V_RATR_B_IDAJUCTREC,   @V_RATR_B_IDSTATREC,   @V_RATR_B_VRRATAJBOLREC;
         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (@V_RATR_B_IDAJUCTREC = 'D') BEGIN
               SET @V_VRAJBOLREC = ROUND(@V_RATR_B_VRRATAJBOLREC, 2);
            END
            ELSE BEGIN
               SET @V_VRAJBOLREC = ROUND(@V_RATR_B_VRRATAJBOLREC * -1, 2);
            END;
            /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_RATR_B_CDEMPRESA,
                                         @V_RATR_B_CDFIMOVFLREC,
                                         @V_RATR_B_DTMOVFLUXO,
                                         @V_RATR_B_IDMOVFLUXO,
                                         @V_RATR_B_CDCLASSFINA,
                                         @V_VRAJBOLREC,
                                         0;

            DELETE FROM MOVFXAJBOLR
            WHERE CDFILIBOLREC = @V_BOLETREC_AB_CDFILIBOLREC AND
                  NRLANBOLREC  = @V_BOLETREC_AB_NRLANBOLREC  AND
                  CDAJUCTREC   = @V_RATR_B_CDAJUCTREC;

            FETCH NEXT FROM C_RATR_B INTO @V_RATR_B_CDFILIAL,     @V_RATR_B_NRLANBOLREC, @V_RATR_B_CDAJUCTREC,
                                          @V_RATR_B_VRAJBOLREC,   @V_RATR_B_CDCLASSFINA, @V_RATR_B_CDEMPRESA,
                                          @V_RATR_B_CDFIMOVFLREC, @V_RATR_B_DTMOVFLUXO,  @V_RATR_B_IDMOVFLUXO,
                                          @V_RATR_B_IDAJUCTREC,   @V_RATR_B_IDSTATREC,   @V_RATR_B_VRRATAJBOLREC;
         END;
         CLOSE C_RATR_B;
         DEALLOCATE C_RATR_B;

         DECLARE C_AJCTREC_B CURSOR FOR
            SELECT AJ.CDFILIAL,    AJ.NRLANCTONF,   AJ.CDAJUCTREC,
                   AJ.CDCLASSFINA, AJ.CDEMMFAJCNTR, AJ.CDFIMFAJCNTR,
                   AJ.DTMOVFLUXO,  AJ.IDMOVFLUXO,   AJ.VRAJUSTEREC,
                   TA.IDAJUCTREC,  AJ.NRSEQVENREC,  AJ.NRPARCELAREC
            FROM AJCTRECEBER AJ, TIPOAJRECEBER TA
            WHERE (AJ.CDFILIAL     = @V_BOLETREC_AB_CDFILIAL)     AND
                  (AJ.NRLANCTONF   = @V_BOLETREC_AB_NRLANCTONF)   AND
                  (AJ.NRSEQVENREC  = @V_BOLETREC_AB_NRSEQVENREC)  AND
                  (AJ.NRPARCELAREC = @V_BOLETREC_AB_NRPARCELAREC) AND
                  (TA.CDAJUCTREC   = AJ.CDAJUCTREC);
         OPEN C_AJCTREC_B;
         FETCH NEXT FROM C_AJCTREC_B INTO @V_AJCTREC_B_CDFILIAL,    @V_AJCTREC_B_NRLANCTONF,   @V_AJCTREC_B_CDAJUCTREC,
                                          @V_AJCTREC_B_CDCLASSFINA, @V_AJCTREC_B_CDEMMFAJCNTR, @V_AJCTREC_B_CDFIMFAJCNTR,
                                          @V_AJCTREC_B_DTMOVFLUXO,  @V_AJCTREC_B_IDMOVFLUXO,   @V_AJCTREC_B_VRAJUSTEREC,
                                          @V_AJCTREC_B_IDAJUCTREC,  @V_AJCTREC_B_NRSEQVENREC,  @V_AJCTREC_B_NRPARCELAREC;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (@V_AJCTREC_B_IDAJUCTREC = 'D') BEGIN
               SET @V_VRAJUCTREC = ROUND(@V_AJCTREC_B_VRAJUSTEREC, 2);
            END
            ELSE BEGIN
               SET @V_VRAJUCTREC = ROUND(@V_AJCTREC_B_VRAJUSTEREC * -1, 2);
            END;
            /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJCTREC_B_CDEMMFAJCNTR,
                                         @V_AJCTREC_B_CDFIMFAJCNTR,
                                         @V_AJCTREC_B_DTMOVFLUXO,
                                         @V_AJCTREC_B_IDMOVFLUXO,
                                         @V_AJCTREC_B_CDCLASSFINA,
                                         @V_VRAJUCTREC,
                                         0;

            DELETE FROM AJCTRECEBER
            WHERE
               (CDFILIAL     = @V_AJCTREC_B_CDFILIAL)     AND
               (NRLANCTONF   = @V_AJCTREC_B_NRLANCTONF)   AND
               (NRSEQVENREC  = @V_AJCTREC_B_NRSEQVENREC)  AND
               (NRPARCELAREC = @V_AJCTREC_B_NRPARCELAREC);

            FETCH NEXT FROM C_AJCTREC_B INTO @V_AJCTREC_B_CDFILIAL,    @V_AJCTREC_B_NRLANCTONF,   @V_AJCTREC_B_CDAJUCTREC,
                                             @V_AJCTREC_B_CDCLASSFINA, @V_AJCTREC_B_CDEMMFAJCNTR, @V_AJCTREC_B_CDFIMFAJCNTR,
                                             @V_AJCTREC_B_DTMOVFLUXO,  @V_AJCTREC_B_IDMOVFLUXO,   @V_AJCTREC_B_VRAJUSTEREC,
                                             @V_AJCTREC_B_IDAJUCTREC,  @V_AJCTREC_B_NRSEQVENREC,  @V_AJCTREC_B_NRPARCELAREC;
         END;
         CLOSE C_AJCTREC_B;
         DEALLOCATE C_AJCTREC_B;

         SET @V_VRORIGREC = @V_BOLETREC_AB_VRORIGREC * (-1);
         /* - DESFAZ O FLUXO DE CAIXA -------------------------- */
         EXEC ATUALIZA_FLUXO_DE_CAIXA @V_BOLETREC_AB_CDEMPRESA,
                                      @V_BOLETREC_AB_CDFIMOVFLREC,
                                      @V_BOLETREC_AB_DTMOVFLUXO,
                                      @V_BOLETREC_AB_IDMOVFLUXO,
                                      @V_BOLETREC_AB_CDCLASSFINA,
                                      @V_VRORIGREC,
                                      0;

         DELETE FROM CONTARECEBER
         WHERE CDFILIBOLREC = @V_BOLETREC_AB_CDFILIBOLREC AND
               NRLANBOLREC  = @V_BOLETREC_AB_NRLANBOLREC;

         FETCH NEXT FROM C_BOLETREC_AB INTO @V_BOLETREC_AB_CDFILIAL,     @V_BOLETREC_AB_NRLANCTONF,  @V_BOLETREC_AB_NRSEQVENREC,
                                            @V_BOLETREC_AB_CDFILIBOLREC, @V_BOLETREC_AB_NRLANBOLREC, @V_BOLETREC_AB_CDEMPRESA,
                                            @V_BOLETREC_AB_CDFIMOVFLREC, @V_BOLETREC_AB_DTMOVFLUXO,  @V_BOLETREC_AB_IDMOVFLUXO,
                                            @V_BOLETREC_AB_CDCLASSFINA,  @V_BOLETREC_AB_VRORIGREC,   @V_BOLETREC_AB_NRPARCELAREC
      END;
      CLOSE C_BOLETREC_AB;
      DEALLOCATE C_BOLETREC_AB;

      DELETE FROM AJBOLREC
      WHERE CDFILIAL    = @V_CNTREC_CDFILIBOLREC AND
            NRLANBOLREC = @V_CNTREC_NRLANBOLREC;

      DELETE FROM BOLETRECEBER
      WHERE CDFILIAL    = @V_CNTREC_CDFILIBOLREC AND
            NRLANBOLREC = @V_CNTREC_NRLANBOLREC;

      FETCH NEXT FROM C_CNTREC INTO @V_CNTREC_CDFILIAL,    @V_CNTREC_NRLANCTONF,   @V_CNTREC_NRSEQVENREC,
                                    @V_CNTREC_VRATUAREC,   @V_CNTREC_CDFILIBOLREC, @V_CNTREC_NRLANBOLREC,
                                    @V_CNTREC_CDEMPRESA,   @V_CNTREC_CDFIMOVFLREC, @V_CNTREC_DTMOVFLUXO,
                                    @V_CNTREC_IDMOVFLUXO,  @V_CNTREC_CDCLASSFINA,  @V_CNTREC_VRORIGREC,
                                    @V_CNTREC_NRPARCELAREC;
   END;
   CLOSE C_CNTREC;
   DEALLOCATE C_CNTREC;
END;
GO
