function ger10120_segmento_mercado_controller(General) {
    
    /**
     * Função para salvar um novo segmento
     * de mercado.
     * 
     * @param {object} widget ativa, no modo
     * de edição, onde contém os valores do novo
     * segmento de mercado.
    */
    this.saveMarketSegment = function(widget){
        
        this.setMarketSegmentDefaultValues(widget);
        
        General.widgetSave(widget).then(function(response){
            widget.reload();
        });
           
    };
   
    /**
     * Função para setar os valores padrão
     * do novo segmento de mercado.
     * 
     * @param {object} widget widget que receberá
     * os valores padrão em sua currentRow.
    */
    this.setMarketSegmentDefaultValues = function(widget){
        
        var currentRow = widget.currentRow;
        
        currentRow.DTULTATUSEGM = "";
        currentRow.CDPRECOPROP = "";
    };
    
}

Configuration(function (ContextRegister) {
    ContextRegister.register("ger10120_segmento_mercado_controller", ger10120_segmento_mercado_controller);
});

