var ZeedhiFields = angular.module("ZeedhiFields");

ZeedhiFields.directive('zhFieldTag', function($compile, $timeout, templateManager, maskEngine, ZhUtil) {
	return {
		link: function($scope, elem) {
			
			var field = $scope.field;
			var fieldElement  = elem.find('input');
			var tags = [];
			
			//Commas, tabs and enters insert tags
			//Backspace remove the last tag
		   fieldElement.keydown(function(e) {
        	   var flagKeyPressed = e.keyCode == 9 || e.keyCode == 13 || e.keyCode == 188;
        	   if(flagKeyPressed && fieldElement.val() !== undefined && (fieldElement.val() !== '' && fieldElement.val() !== field.tip)){
        	   	    //Avoid jumping to next field
        			e.preventDefault();
        			__checkFlagKeys(e, field);
        	   }else if(e.keyCode == 8 && fieldElement.val() === ''){
        	   	    //Avoid backspace in the last word of the last tag
        	   	    e.preventDefault();
        			__removeTag();		
        	   }
        	});
        	
        	function __checkFlagKeys($event, field){
        		var keyCode = $event.keyCode;
        		if(keyCode == 188 || keyCode == 9 || keyCode == 13){
        		    field.val = fieldElement.val();
        		    //If comma, slice it
        			var value = keyCode == 188 ? field.val.slice(0, field.val.length) : field.val;
        			__insertTag(value);
        			fieldElement.val(field.tip || '');
        			
        		}
        	};
        	
        	function __insertTag(value){
        		var container = elem.find('.zh-tag-options-container');
        		var item	  = $compile('<span class="zh-tag"><span zh-touchstart="removeTag(evt)">×</span>'+value+'</span>')($scope);
        		var currentTextIndent = __getCurrentIndent();
        		container.append(item);
        		item = elem.find('.zh-tag-options-container').find('.zh-tag').last();
        		//Jump the cursor to the front of the current Tag
        		fieldElement.css('text-indent', currentTextIndent+12+item.width());
        		buildTags(item, 'add');
        	}
        	
        	function __removeTag(){
        		var lastItem = elem.find('.zh-tag-options-container').find('.zh-tag').last();
        		if(lastItem[0]){
	        		var text	 = lastItem[0].textContent;
	        		//slice the 'x' used to remove tags onClick
	        		text = text.slice(1, text.length);
	        		
	        		fieldElement.css('text-indent', __getCurrentIndent()-lastItem.width()-12);
	        		
	        		fieldElement.val(text);
	        		
	        		buildTags(lastItem, 'remove');
	        		
	        		lastItem.remove();
        		}
        	}
		    
		    function __getCurrentIndent(){
		    	return elem.find('.zh-tag-options-container').width();
		    }
		    
		    $scope.$watch(function () {
		        return elem.find('.zh-tag-options-container').width();
		       }, function(newVal, oldVal) {
		       	//Create scroll if we have more tags than the screen allow
		        if(newVal > fieldElement.width()){
		        	elem.find('.zh-tag-options-container').css({
		        		'overflow-x':'scroll',
		        		'overflow-y':'hidden',
		        	    'white-space': 'nowrap',
		        	    'width':'100%',
		        	});
		        }else{
		        	elem.find('.zh-tag-options-container').css({
		        		'overflow-x':'visible',
		        		'overflow-y':'visible',
		        	    'white-space': 'auto',
		        	    'width':'auto',
		        	})
		        }
			});
			
			$scope.removeTag = function(evt) {
				var elm = angular.element(evt.currentTarget.parentElement);
				if (!field.isReadOnly()) {
					elm.animate({
						opacity: 0,
					}, 300, function() {
						fieldElement.css('text-indent', __getCurrentIndent()-elm.width()-12);
						fieldElement.focus();
						elm.remove();
						buildTags(elm, 'remove');
					});
				}
				evt.stopPropagation();
			};
			
			function buildTags(element, action){
				if(action === 'remove'){
					tags.splice(element.index(), 1);
					var width = 0;
					elem.find('.zh-tag-options-container').children().each(function(){
						width += $(this).width()+12;
					});
					//Remove the scroll if the new width fit into the screen
					if(width < elem.find('.zh-tag-options-container').width()){
						elem.find('.zh-tag-options-container').css({
							'overflow-x':'visible',
			        		'overflow-y':'visible',
			        	    'white-space': 'auto',
			        	    'width':'auto',
						});	
					}
				}else if(action === 'add'){
					var text = element[0].textContent;
					tags.push(text.slice(1, text.length));
				}
				field.widget.currentRow[field.name] = tags;
			}
			
			$scope.$watch(function () {
		        return field.widget.mode;
		       }, function(newVal, oldVal) {
		       	//When edit we have to build the tags again
		        if(newVal === 'edit' && !Util.isEmptyOrBlank(field.widget.currentRow[field.name])){
		        	var tagsToBuild = field.widget.currentRow[field.name];
		        	tagsToBuild = Array.isArray(tagsToBuild) ? tagsToBuild : tagsToBuild.split(',');
		        	tagsToBuild.forEach(function(item){
		        		__insertTag(item);	
		        	});
		        }
		        fieldElement.val(field.tip || '');
			}.bind(this));
		}
	};
});